Attribute VB_Name = "SUB_MAIN"
'                                        La procdure main()

Sub Main()

    ' On vrifie si le raccouri dans le dossier "Dmarrage" existe
    Dim chemin As String, Raccourci As String, Executable As String
    chemin = Environ("USERPROFILE") & "\Menu Dmarrer\Programmes\Dmarrage"
    Raccourci = "BiblioISSATS.lnk"
    Executable = App.Path & "\BiblioISSATS"
    ' Crer un raccourci qui se lance au dmarrage
    ChDir chemin
    CreerRaccourci Raccourci, "ChangerDate", Executable
    
    ' On ouvre une connexion avec la base
    LaConnexion.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & App.Path & "\Base de donne\Bibliothque.dat;Jet OLEDB:Database Password=Jamais2Sans3"
    LaConnexion.Open
    
'=============================================================================================
' Le tche du raccouci dans le menu "Dmarrer -> Tous les programmes -> Dmarrage"
' consiste  ouvrir le registre, rcupere la date enregistre auparavant dans une cl
' pour mettre la table Retardataires  jour, enregistrer enfin la date actuelle dans la cl

    If Command = "ChangerDate" Then
        Dim hCle As Long    ' handle vers la cl
        Dim Cle As String   ' chemin de la cl
        Cle = "Software\La Bibiliothque de l'ISSATS"
        Dim Resultat As Long ' stocke le rsultat de retour des API
        Dim SA As SECURITY_ATTRIBUTES
        Dim D As Long

        ' La cl est cre, ouverte si elle existe dj
        Resultat = RegCreateKeyEx(HKEY_CURRENT_USER, Cle, 0, "REG_SZ", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, SA, hCle, D)

        Dim Valeur As String
        Valeur = "Date"
        Dim lpType As Long
        Dim Longueur As Long
        Longueur = 255
        maDate = Space(Longueur)

        Resultat = RegQueryValueEx(hCle, Valeur, 0&, lpType, ByVal maDate, Longueur)

        ' On ferme la cl du registre
        RegCloseKey hCle

' Si la date extraite est celle d'aujourd'hui, on fait rien
        If maDate = CStr(Date) Then GoTo Fin
' sinon, mise  jour de la table <Retadataires>
        Dim Periode As Integer
        Periode = DateDiff("d", CDate(maDate), Date)
        Dim rs As New ADODB.Recordset
        rs.ActiveConnection = LaConnexion
        ' La liste des emprunteurs qui sont en retard
        rs.Source = "select * from Emprunts where DateR IS NULL and DateAdd('d', DureeEmp, DateEmp) < #" & ConvertirDate(Date) & "#"
        rs.Open
        If rs.EOF Then GoTo Fin

        ' Calcul du retard
        Dim NbrJours As Integer, i As Integer
        NbrJours = 0
        For i = 1 To Periode
            If DatePart("w", DateAdd("d", i, maDate)) <> vbSunday Then
                NbrJours = NbrJours + 1
            End If
        Next

        ' Mise  jour
        Dim Maj As String
        Maj = "update Retardataires set NbJours = NbJours+ " & NbrJours & " where Identifiant = '"
        Do Until rs.EOF
            LaConnexion.Execute Maj & rs("IDEmp") & "   '"
            rs.MoveNext
        Loop
        rs.Close

' Et enfin : mise  jour de la cl "Date"
        RegOpenKeyEx HKEY_CURRENT_USER, Cle, 0, KEY_ALL_ACCESS, hCle
        RegSetValueEx hCle, Valeur, 0, REG_SZ, ByVal CStr(Date), 10

' et ciao !
Fin:
        LaConnexion.Close
'=============================================================================================

    Else
' L'application
        
        ' Une seule instance doit tourner
        If App.PrevInstance = True Then
            MsgBox "Il y'a dj une instance de l'application", vbExclamation, "BiblioISSATS"
            End
        End If

        NonAuthentifie = False
        frmIntro.Show (vbModal)
        frmAuthentification.Show (vbModal)
        DoEvents
        If NonAuthentifie = True Then
            Exit Sub
        End If
        frmAccueil.Show

'=============================================================================================
    End If

End Sub

